=== debian/changelog ===
neko (1.8.1-6ubuntu4) raring; urgency=low

  * Rebuild to pick up the new libgc1c3 dependency.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Feb 2013 13:39:51 +0000

neko (1.8.1-6ubuntu3) quantal; urgency=low

  * Rebuild to correct the compile-time-selected linker path on armhf.
  * Move the as-needed fix from a debian-changes patch to its own.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 11 Oct 2012 00:03:59 -0600

neko (1.8.1-6ubuntu2) precise; urgency=low

  * Rebuild for libmysqlclient transition

 -- Clint Byrum <clint@ubuntu.com>  Wed, 23 Nov 2011 23:58:41 -0800

neko (1.8.1-6ubuntu1) oneiric; urgency=low

  * Fix FTBFS with ld --as-needed. LP: #771060.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Sep 2011 15:45:59 +0200

neko (1.8.1-6) unstable; urgency=low

  * Include patch to fix compile errors on hurd-i386, thanks to Pino
    Toscano.
    (Closes: #626260)

 -- Jens Peter Secher <jps@debian.org>  Sun, 15 May 2011 18:44:31 +0200

neko (1.8.1-5) unstable; urgency=low

  * Avoid spurious build failures (stack overflows and segmentation
    faults) by using both -fno-strict-aliasing and lower optimisation
    level.
    (Closes: #569806)

 -- Jens Peter Secher <jps@debian.org>  Thu, 18 Feb 2010 22:26:27 +0100

neko (1.8.1-4) unstable; urgency=low

  * Attempt to fix executable_path() on kFreeBSD, which only seemed to
    work when invoked from bash, thanks to Roman Neuhauser.

 -- Jens Peter Secher <jps@debian.org>  Sat, 13 Feb 2010 16:34:13 +0100

neko (1.8.1-3) unstable; urgency=low

  * Converted to dpkg-source format 3.0 (quilt).
  * Use mercurial-buildpackage for repository maintenance, so old
    repository does not exist any more.
  * Bumped Standards-Version to 3.8.4, no change.
  * Use misc:Depends macro for all binary packages, and tighten depency
    for the header-files package.

 -- Jens Peter Secher <jps@debian.org>  Sat, 13 Feb 2010 15:20:34 +0100

neko (1.8.1-2) unstable; urgency=low

  * Do not install broken mysql5.ndll library.  The dynamically linked
    mysql.ndll works fine for all versions of MySql.
    (Closes: #542024)
  * Build-Depend on generic libmysqlclient-dev instead of specific
    version.
  * Fixed build failure on kFreeBSD, thanks to Cyril Brulebois.
    (Closes: #543995)
  * Bumped the Standards-Version to 3.8.3, no changes.

 -- Jens Peter Secher <jps@debian.org>  Wed, 09 Sep 2009 14:40:17 +0200

neko (1.8.1-1) unstable; urgency=low

  * New upstream version.
  * Bump SONAME to libneko.0.1 and make libneko0 conflict with previous
    version of neko-dev.
  * Change libapache2-mod-neko package section to httpd, and updated
    Standards-Version to 3.8.2.
  * Removed obsolete patch tora-pwrite-diversion.diff.
  * Added tora-missing-include.diff to include stdlib.h.
  * Added mysql-missing-include.diff to include stdlib.h.
    
 -- Jens Peter Secher <jps@debian.org>  Tue, 28 Jul 2009 22:32:00 +0200

neko (1.8.0-4) unstable; urgency=low

  * Fix broken NDLLs (shared libraries) by reverting some of the previous
    changes.

 -- Jens Peter Secher <jps@debian.org>  Sat, 28 Mar 2009 09:40:24 +0100

neko (1.8.0-3) unstable; urgency=low

  * Fix build failure on MIPS by tightening up the linking process.
  * Make neko-dev architecture independent since there are no binary files
    in neko-dev.
  * Bumped the Standards-Version to 3.8.1.
  * Bumped debhelper version to 7.

 -- Jens Peter Secher <jps@debian.org>  Thu, 26 Mar 2009 20:00:40 +0100

neko (1.8.0-2) unstable; urgency=low

  * Promoted libneko to a proper shared library living in /usr/lib.
    (Closes: #509454)    
  * No need to Build-Conflict with itself because all rpaths have been
    removed.
  * Use quilt instead of dpatch for patches, and describe how to use
    quilt in Debian.source (thanks to Russ Allbery).
  * Strip all shared libraries.
  * Put test.n and test.neko in examples directory.
  * Added a Vcs-Hg control filed to indicate the location of the public
    repository.
  * Bumped the Standards-Version to 3.8.0.

 -- Jens Peter Secher <jps@debian.org>  Sat, 14 Mar 2009 21:01:12 +0100

neko (1.8.0-1) experimental; urgency=low

  * New upstream release.
  * Bumped debhelper version to 6.

 -- Jens Peter Secher <jps@debian.org>  Sat, 04 Oct 2008 16:44:58 +0200

neko (1.7.1-1~bpo40+1) etch-backports; urgency=low

  * Backport to Etch (no change).

 -- Jens Peter Secher <jps@debian.org>  Sun, 03 Aug 2008 13:32:05 +0200

neko (1.7.1-1) unstable; urgency=low

  * New upstream release.
  * Call dh_makeshlibs before dh_installdeb in debian/rules.
  * Define _GNU_SOURCE to get threads to work.

 -- Jens Peter Secher <jps@debian.org>  Thu, 31 Jul 2008 13:17:14 +0200

neko (1.7.0-1) unstable; urgency=low

  * New upstream release.

 -- Jens Peter Secher <jps@debian.org>  Thu, 27 Mar 2008 20:53:37 +0100

neko (1.6.0-4~bpo40+2) etch-backports; urgency=low

  * Pass version extracted by dpkg-parsechangelog to dh_makeshlibs instead
    of error prone hard-coding.

 -- Jens Peter Secher <jps@debian.org>  Tue, 27 Nov 2007 21:09:43 +0100

neko (1.6.0-4~bpo40+1) etch-backports; urgency=low

  * Without the Homepage field.

 -- Jens Peter Secher <jps@debian.org>  Tue, 27 Nov 2007 21:09:43 +0100

neko (1.6.0-4) unstable; urgency=low

  * Give libneko a proper SONAME to avoid breakage by new dpkg-shlibdeps.
  * Avoid a lot of unnecessary shared library dependencies.
  * Place the apache module in section web.
  * Use the Homepage field in the control file.
  * Bump debhelper to version 5.

 -- Jens Peter Secher <jps@debian.org>  Mon, 26 Nov 2007 19:03:00 +0100

neko (1.6.0-3) unstable; urgency=low

  * Fixed missing reference to shared mysqlclient library.

 -- Jens Peter Secher <jps@debian.org>  Tue, 13 Nov 2007 00:42:42 +0100

neko (1.6.0-2~bpo40+1) etch-backports; urgency=low

  * Backport to Etch (no change).

 -- Jens Peter Secher <jps@debian.org>  Sat, 08 Sep 2007 14:16:50 +0200

neko (1.6.0-2) unstable; urgency=low

  * Support non-stripped builds (DEB_BUILD_OPTIONS=nostrip).

