=== debian/changelog ===
neko (2.0.0-4build1) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 12:48:05 +0000

neko (2.0.0-4) unstable; urgency=low

  * Adopt package (Closes: #628939).
    + Set maintainer to myself.
  * Set Vcs-* fields to Haxe Foundation neko-debian git repo.
  * Bump Standards-Version to 3.9.6 (no changes).
  * Bump debhelper and compat level to 9.
  * Clean up d/rules.
  * Include patch to add dpkg-buildflags CFLAGS when compiling ndlls.
  * Add d/watch and get-orig-source target.
  * Convert d/copyright to format 1.0.
  * Add bash-completion, thanks to Tong.
  * Include patch of the upstream fix on JIT.

 -- Andy Li <andy@onthewings.net>  Sat, 19 Sep 2015 02:38:21 +0800

neko (2.0.0-3) unstable; urgency=low

  * QA upload.
  * Convert to dh-apache2.
  * Switch MPM to prefork in postinst; do not depend on apache2-mpm-prefork.

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Jul 2013 15:30:16 +0100

neko (2.0.0-2) unstable; urgency=low

  * QA upload.
  * Update copyright, changed to BSD.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Jul 2013 16:32:32 +0200

neko (2.0.0-1) unstable; urgency=low

  * QA upload.
  * New upstream version.
  * Properly orphan the package (see #628939).
  * Build-depend on apache2-dev, fix build errors with apache2.4.
    Closes: #666858.
  * Fix build failure with ld --as-needed. Closes: #641613.
  * Fix some lintian warnings.
  * TODO: Pass build flags to submodules. 

 -- Matthias Klose <doko@debian.org>  Fri, 05 Jul 2013 14:47:28 +0200
