=== debian/control ===
Source: neko
Section: interpreters
Priority: optional
Maintainer: Andy Li <andy@onthewings.net>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), pkg-config, libgc-dev, dh-apache2, apache2-dev, libmysqlclient-dev, libsqlite3-dev, libpcre3-dev, libapr1-dev, libgtk2.0-dev, bash-completion
Vcs-Git: https://github.com/HaxeFoundation/neko-debian.git
Vcs-Browser: https://github.com/HaxeFoundation/neko-debian
Homepage: http://nekovm.org

Package: libneko0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: neko (<< 1.8.0-2), neko-dev (<< 1.8.1)
Description: Lightweight virtual machine - shared library
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 This is the shared library implementing the Neko virtual machine.
 .
 Neko was written by Nicolas Cannasse.

Package: neko-dev
Architecture: all
Section: libdevel
Depends: libneko0 (>= ${source:Upstream-Version}), libneko0 (<<  ${source:Upstream-Version}+1~), ${misc:Depends}
Conflicts: neko (<< 1.8.0-2)
Description: Lightweight virtual machine - headers
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 The virtual machine is both very lightweight and well optimized.  It
 can be easily embedded into other applications, and libraries are
 directly accessible using the C foreign function interface.
 .
 This package includes the header files for development using the Neko
 virtual machine.
 .
 Neko was written by Nicolas Cannasse.

Package: neko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libapache2-mod-neko, neko-dev
Description: Lightweight virtual machine - compiler and tools
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 The compiler converts a source file (.neko) into a bytecode file (.n)
 that can be executed with the Virtual Machine.  You can use the
 compiler as standalone commandline executable separated from the
 virtual machine, or as a Neko library to perform compile-and-run for
 interactive languages.
 .
 Neko was written by Nicolas Cannasse.

Package: libapache2-mod-neko
Architecture: all
Section: httpd
Depends: neko (>= ${source:Version}), ${misc:Depends}
Description: Apache module for running server-side Neko programs
 Neko provides a common runtime for several different languages,
 including JavaScript and haXe.
 .
 This package includes a module for Apache 2 so that you can
 dynamically generate server-side web pages from Apache.
 .
 Neko was written by Nicolas Cannasse.
