=== debian/changelog ===
neko (2.1.0-4) unstable; urgency=medium

  * Updated dependencies of mariadb and mysql (Closes: #843841).
  * Enabled hardening (hardening=+all).

 -- Andy Li <andy@onthewings.net>  Thu, 10 Nov 2016 22:56:04 +0800

neko (2.1.0-3) unstable; urgency=medium

  * Added upstream patches
    + boot-c-1.diff and boot-c-2.diff: build nekoc, nekoml, and 
      nekotools with "nekotools boot -c file.n", such that the 
      output will be valid binaries.
    + tests-1.diff and tests-2.diff: add tests that run nekoc,
      nekoml, and nekotools.

 -- Andy Li <andy@onthewings.net>  Fri, 10 Jun 2016 18:21:00 +0800

neko (2.1.0-2) unstable; urgency=low

  * Added upstream patch, mincoming-stack-boundary.diff, that avoids
    using unavailable compiler flag (Closes: #825903).

 -- Andy Li <andy@onthewings.net>  Tue, 07 Jun 2016 08:16:58 +0800

neko (2.1.0-1) unstable; urgency=low

  * New upstream version.
    + Upstream now uses CMake to build.
    + libneko is now versioned in upstream. (libneko2)
    + The "nekotools booted" binaries can now be stripped correctly.
    + Use MariaDB for compiling mysql.ndll.
    + Updated d/copyright.
  * Fixed shlibdeps for the neko package.
  * Removed patches applied to upstream. Updated hurd.diff.
  * Updated d/watch pattern.
  * Bump Standards-Version to 3.9.8 (no changes).

 -- Andy Li <andy@onthewings.net>  Thu, 19 May 2016 22:00:37 +0800
