=== debian/watch ===
version=3
http://nekovm.org/download .*/neko-(\d\.\d\.\d)-src\.tar\.gz
